/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptiondockwidgetv2_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionDockWidgetV2_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionDockWidgetV2 >()))
        return -1;

    QStyleOptionDockWidgetV2* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionDockWidgetV2", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionDockWidgetV2()
    // 1: QStyleOptionDockWidgetV2(QStyleOptionDockWidget)
    // 2: QStyleOptionDockWidgetV2(QStyleOptionDockWidgetV2)
    // 3: QStyleOptionDockWidgetV2(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionDockWidgetV2()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 3; // QStyleOptionDockWidgetV2(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionDockWidgetV2 >::isConvertible(pyargs[0])) {
        overloadId = 2; // QStyleOptionDockWidgetV2(QStyleOptionDockWidgetV2)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionDockWidget >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionDockWidgetV2(QStyleOptionDockWidget)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionDockWidgetV2_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionDockWidgetV2()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionDockWidgetV2()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionDockWidgetV2();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionDockWidgetV2(QStyleOptionDockWidget)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionDockWidget cppArg0 = Shiboken::Converter<QStyleOptionDockWidget >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionDockWidgetV2(QStyleOptionDockWidget)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionDockWidgetV2(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionDockWidgetV2(QStyleOptionDockWidgetV2)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionDockWidgetV2 cppArg0 = Shiboken::Converter<QStyleOptionDockWidgetV2 >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionDockWidgetV2(QStyleOptionDockWidgetV2)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionDockWidgetV2(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 3: // QStyleOptionDockWidgetV2(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionDockWidgetV2(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionDockWidgetV2(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionDockWidgetV2 >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionDockWidgetV2_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionDockWidgetV2_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionDockWidget", "PySide.QtGui.QStyleOptionDockWidgetV2", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionDockWidgetV2", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionDockWidgetV2___copy__(PyObject *self)
{
        QStyleOptionDockWidgetV2* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionDockWidgetV2*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionDockWidgetV2* copy = new QStyleOptionDockWidgetV2(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionDockWidgetV2*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionDockWidgetV2_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionDockWidgetV2___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionDockWidgetV2_get_verticalTitleBar(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< bool >::toPython( Shiboken::Converter< QStyleOptionDockWidgetV2* >::toCpp(self)->verticalTitleBar);
    return val;
}

static int Sbk_QStyleOptionDockWidgetV2_set_verticalTitleBar(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'verticalTitleBar' may not be deleted");
        return -1;
    }
    if (!SbkNumber_Check(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'verticalTitleBar', 'bool' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionDockWidgetV2* >::toCpp(self)->verticalTitleBar = Shiboken::Converter< bool >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionDockWidgetV2
static PyGetSetDef Sbk_QStyleOptionDockWidgetV2_getsetlist[] = {
    {const_cast<char*>("verticalTitleBar"), Sbk_QStyleOptionDockWidgetV2_get_verticalTitleBar, Sbk_QStyleOptionDockWidgetV2_set_verticalTitleBar},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionDockWidgetV2_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionDockWidgetV2",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionDockWidgetV2_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionDockWidgetV2_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionDockWidgetV2_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleOptionDockWidgetV2(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONDOCKWIDGETV2_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionDockWidgetV2_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionDockWidgetV2_Type);
    Sbk_QStyleOptionDockWidgetV2_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONDOCKWIDGET_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionDockWidgetV2_Type, &Shiboken::callCppDestructor<QStyleOptionDockWidgetV2 >);
    Py_INCREF((PyObject*)&Sbk_QStyleOptionDockWidgetV2_Type); //Incref due the 'PyModule_AddObject' steals the reference.
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionDockWidgetV2_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionDockWidgetV2_Type, "QStyleOptionDockWidgetV2");
    PyModule_AddObject(module, "QStyleOptionDockWidgetV2",
        ((PyObject*)&Sbk_QStyleOptionDockWidgetV2_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionDockWidgetV2_StyleOptionVersion = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionDockWidgetV2.StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONDOCKWIDGETV2_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionDockWidgetV2_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionDockWidgetV2_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionDockWidgetV2_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionDockWidgetV2_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionDockWidgetV2_StyleOptionVersion,(long) QStyleOptionDockWidgetV2::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionDockWidgetV2_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionDockWidgetV2_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionDockWidgetV2::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionDockWidgetV2 >("QStyleOptionDockWidgetV2");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionDockWidgetV2 >("QStyleOptionDockWidgetV2*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionDockWidgetV2 >(typeid(QStyleOptionDockWidgetV2).name());
    qRegisterMetaType< ::QStyleOptionDockWidgetV2 >("QStyleOptionDockWidgetV2");
    qRegisterMetaType< ::QStyleOptionDockWidgetV2::StyleOptionVersion >("QStyleOptionDockWidgetV2::StyleOptionVersion");
}

