/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptiontoolbutton_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionToolButton_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionToolButton >()))
        return -1;

    QStyleOptionToolButton* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionToolButton", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionToolButton()
    // 1: QStyleOptionToolButton(QStyleOptionToolButton)
    // 2: QStyleOptionToolButton(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionToolButton()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 2; // QStyleOptionToolButton(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionToolButton >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionToolButton(QStyleOptionToolButton)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionToolButton_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionToolButton()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionToolButton()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionToolButton();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionToolButton(QStyleOptionToolButton)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionToolButton cppArg0 = Shiboken::Converter<QStyleOptionToolButton >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionToolButton(QStyleOptionToolButton)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionToolButton(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionToolButton(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionToolButton(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionToolButton(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionToolButton >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionToolButton_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionToolButton_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionToolButton", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionToolButton", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionToolButton___copy__(PyObject *self)
{
        QStyleOptionToolButton* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionToolButton*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionToolButton* copy = new QStyleOptionToolButton(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionToolButton*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionToolButton_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionToolButton___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionToolButton_get_iconSize(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->iconSize);
    Shiboken::Object::releaseOwnership(val);
    Shiboken::Object::setParent(self, val);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_iconSize(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'iconSize' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QSize >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'iconSize', 'QSize' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->iconSize = Shiboken::Converter< ::QSize >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionToolButton_get_toolButtonStyle(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< ::Qt::ToolButtonStyle >::toPython( Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->toolButtonStyle);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_toolButtonStyle(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'toolButtonStyle' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::Qt::ToolButtonStyle >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'toolButtonStyle', 'ToolButtonStyle' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->toolButtonStyle = Shiboken::Converter< ::Qt::ToolButtonStyle >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionToolButton_get_features(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< ::QFlags<QStyleOptionToolButton::ToolButtonFeature> >::toPython( Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->features);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_features(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'features' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QFlags<QStyleOptionToolButton::ToolButtonFeature> >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'features', 'ToolButtonFeatures' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->features = Shiboken::Converter< ::QFlags<QStyleOptionToolButton::ToolButtonFeature> >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionToolButton_get_arrowType(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< ::Qt::ArrowType >::toPython( Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->arrowType);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_arrowType(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'arrowType' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::Qt::ArrowType >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'arrowType', 'ArrowType' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->arrowType = Shiboken::Converter< ::Qt::ArrowType >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionToolButton_get_icon(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->icon);
    Shiboken::Object::releaseOwnership(val);
    Shiboken::Object::setParent(self, val);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_icon(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'icon' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QIcon >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'icon', 'QIcon' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->icon = Shiboken::Converter< ::QIcon >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionToolButton_get_pos(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->pos);
    Shiboken::Object::releaseOwnership(val);
    Shiboken::Object::setParent(self, val);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_pos(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'pos' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QPoint >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'pos', 'QPoint' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->pos = Shiboken::Converter< ::QPoint >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionToolButton_get_text(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< QString >::toPython( Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->text);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_text(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'text' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< QString >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'text', 'QString' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->text = Shiboken::Converter< QString >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionToolButton_get_font(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->font);
    Shiboken::Object::releaseOwnership(val);
    Shiboken::Object::setParent(self, val);
    return val;
}

static int Sbk_QStyleOptionToolButton_set_font(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'font' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QFont >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'font', 'QFont' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionToolButton* >::toCpp(self)->font = Shiboken::Converter< ::QFont >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionToolButton
static PyGetSetDef Sbk_QStyleOptionToolButton_getsetlist[] = {
    {const_cast<char*>("iconSize"), Sbk_QStyleOptionToolButton_get_iconSize, Sbk_QStyleOptionToolButton_set_iconSize},
    {const_cast<char*>("toolButtonStyle"), Sbk_QStyleOptionToolButton_get_toolButtonStyle, Sbk_QStyleOptionToolButton_set_toolButtonStyle},
    {const_cast<char*>("features"), Sbk_QStyleOptionToolButton_get_features, Sbk_QStyleOptionToolButton_set_features},
    {const_cast<char*>("arrowType"), Sbk_QStyleOptionToolButton_get_arrowType, Sbk_QStyleOptionToolButton_set_arrowType},
    {const_cast<char*>("icon"), Sbk_QStyleOptionToolButton_get_icon, Sbk_QStyleOptionToolButton_set_icon},
    {const_cast<char*>("pos"), Sbk_QStyleOptionToolButton_get_pos, Sbk_QStyleOptionToolButton_set_pos},
    {const_cast<char*>("text"), Sbk_QStyleOptionToolButton_get_text, Sbk_QStyleOptionToolButton_set_text},
    {const_cast<char*>("font"), Sbk_QStyleOptionToolButton_get_font, Sbk_QStyleOptionToolButton_set_font},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionToolButton_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionToolButton",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionToolButton_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionToolButton_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionToolButton_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern

PyObject* SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionToolButton::ToolButtonFeatures >::toPython(
        Shiboken::Converter<QStyleOptionToolButton::ToolButtonFeatures>::toCpp(self)
        & Shiboken::Converter< QStyleOptionToolButton::ToolButtonFeatures >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionToolButton::ToolButtonFeatures >::toPython(
        Shiboken::Converter<QStyleOptionToolButton::ToolButtonFeatures>::toCpp(self)
        | Shiboken::Converter< QStyleOptionToolButton::ToolButtonFeatures >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionToolButton::ToolButtonFeatures >::toPython(
        Shiboken::Converter<QStyleOptionToolButton::ToolButtonFeatures>::toCpp(self)
        ^ Shiboken::Converter< QStyleOptionToolButton::ToolButtonFeatures >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionToolButton::ToolButtonFeatures >::toPython(
        ~Shiboken::Converter<QStyleOptionToolButton::ToolButtonFeatures >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeatures_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "ToolButtonFeatures",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_QStyleOptionToolButton(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTOOLBUTTON_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionToolButton_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionToolButton_Type);
    Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONCOMPLEX_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionToolButton_Type, &Shiboken::callCppDestructor<QStyleOptionToolButton >);
    Py_INCREF((PyObject*)&Sbk_QStyleOptionToolButton_Type); //Incref due the 'PyModule_AddObject' steals the reference.
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionToolButton_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionToolButton_Type, "QStyleOptionToolButton");
    PyModule_AddObject(module, "QStyleOptionToolButton",
        ((PyObject*)&Sbk_QStyleOptionToolButton_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionVersion = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionToolButton.StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTOOLBUTTON_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionVersion,(long) QStyleOptionToolButton::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionToolButton::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion

    // init enum: ToolButtonFeature
    PyTypeObject* SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionToolButton.ToolButtonFeature");
    SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature->tp_as_number = &SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature_as_number;
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTOOLBUTTON_TOOLBUTTONFEATURE_IDX] = SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,
            "ToolButtonFeature",((PyObject*)SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature));

    // init flags class: QFlags<QStyleOptionToolButton::ToolButtonFeature>
    SbkPySide_QtGuiTypes[SBK_QFLAGS_QSTYLEOPTIONTOOLBUTTON_TOOLBUTTONFEATURE__IDX] = &SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeatures_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeatures_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,
            "ToolButtonFeatures",((PyObject*)&SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeatures_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature,(long) QStyleOptionToolButton::None, "None");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"None", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature->tp_dict,"None", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature,(long) QStyleOptionToolButton::Arrow, "Arrow");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"Arrow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature->tp_dict,"Arrow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature,(long) QStyleOptionToolButton::Menu, "Menu");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"Menu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature->tp_dict,"Menu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature,(long) QStyleOptionToolButton::MenuButtonPopup, "MenuButtonPopup");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"MenuButtonPopup", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature->tp_dict,"MenuButtonPopup", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature,(long) QStyleOptionToolButton::PopupDelay, "PopupDelay");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"PopupDelay", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature->tp_dict,"PopupDelay", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature,(long) QStyleOptionToolButton::HasMenu, "HasMenu");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"HasMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_ToolButtonFeature->tp_dict,"HasMenu", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionToolButton::ToolButtonFeature");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ToolButtonFeature");
    // end of enum ToolButtonFeature

    // init enum: StyleOptionType
    PyTypeObject* SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionType = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionToolButton.StyleOptionType");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTOOLBUTTON_STYLEOPTIONTYPE_IDX] = SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionType;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionType) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,
            "StyleOptionType",((PyObject*)SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionType,(long) QStyleOptionToolButton::Type, "Type");
    PyDict_SetItemString(Sbk_QStyleOptionToolButton_Type.super.ht_type.tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionToolButton_StyleOptionType->tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionToolButton::StyleOptionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionType");
    // end of enum StyleOptionType


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionToolButton >("QStyleOptionToolButton");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionToolButton >("QStyleOptionToolButton*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionToolButton >(typeid(QStyleOptionToolButton).name());
    qRegisterMetaType< ::QStyleOptionToolButton >("QStyleOptionToolButton");
    qRegisterMetaType< ::QStyleOptionToolButton::StyleOptionVersion >("QStyleOptionToolButton::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionToolButton::ToolButtonFeature >("QStyleOptionToolButton::ToolButtonFeature");
    qRegisterMetaType< ::QStyleOptionToolButton::ToolButtonFeatures >("QStyleOptionToolButton::ToolButtonFeatures");
    qRegisterMetaType< ::QStyleOptionToolButton::StyleOptionType >("QStyleOptionToolButton::StyleOptionType");
}

