/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtmultimedia_python.h"

#include "qaudio_wrapper.h"

// Extra includes



// Target ---------------------------------------------------------

extern "C" {
static PyMethodDef Sbk_QAudio_methods[] = {

    {0} // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QAudio_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtMultimedia.QAudio",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QAudio_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              0,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QAudio(PyObject* module)
{
    SbkPySide_QtMultimediaTypes[SBK_QAUDIO_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QAudio_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QAudio_Type);
    Py_INCREF((PyObject*)&Sbk_QAudio_Type); //Incref due the 'PyModule_AddObject' steals the reference.
    if (PyType_Ready((PyTypeObject*)&Sbk_QAudio_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QAudio_Type, "QAudio");
    PyModule_AddObject(module, "QAudio",
        ((PyObject*)&Sbk_QAudio_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: Mode
    PyTypeObject* SbkPySide_QtMultimedia_QAudio_Mode = Shiboken::Enum::newType("PySide.QtMultimedia.QAudio.Mode");
    SbkPySide_QtMultimediaTypes[SBK_QAUDIO_MODE_IDX] = SbkPySide_QtMultimedia_QAudio_Mode;
    if (PyType_Ready(SbkPySide_QtMultimedia_QAudio_Mode) < 0)
        return;
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,
            "Mode",((PyObject*)SbkPySide_QtMultimedia_QAudio_Mode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_Mode,(long) QAudio::AudioInput, "AudioInput");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"AudioInput", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_Mode->tp_dict,"AudioInput", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_Mode,(long) QAudio::AudioOutput, "AudioOutput");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"AudioOutput", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_Mode->tp_dict,"AudioOutput", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QAudio::Mode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Mode");
    // end of enum Mode

    // init enum: Error
    PyTypeObject* SbkPySide_QtMultimedia_QAudio_Error = Shiboken::Enum::newType("PySide.QtMultimedia.QAudio.Error");
    SbkPySide_QtMultimediaTypes[SBK_QAUDIO_ERROR_IDX] = SbkPySide_QtMultimedia_QAudio_Error;
    if (PyType_Ready(SbkPySide_QtMultimedia_QAudio_Error) < 0)
        return;
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,
            "Error",((PyObject*)SbkPySide_QtMultimedia_QAudio_Error));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_Error,(long) QAudio::NoError, "NoError");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"NoError", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_Error->tp_dict,"NoError", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_Error,(long) QAudio::OpenError, "OpenError");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"OpenError", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_Error->tp_dict,"OpenError", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_Error,(long) QAudio::IOError, "IOError");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"IOError", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_Error->tp_dict,"IOError", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_Error,(long) QAudio::UnderrunError, "UnderrunError");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"UnderrunError", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_Error->tp_dict,"UnderrunError", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_Error,(long) QAudio::FatalError, "FatalError");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"FatalError", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_Error->tp_dict,"FatalError", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QAudio::Error");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Error");
    // end of enum Error

    // init enum: State
    PyTypeObject* SbkPySide_QtMultimedia_QAudio_State = Shiboken::Enum::newType("PySide.QtMultimedia.QAudio.State");
    SbkPySide_QtMultimediaTypes[SBK_QAUDIO_STATE_IDX] = SbkPySide_QtMultimedia_QAudio_State;
    if (PyType_Ready(SbkPySide_QtMultimedia_QAudio_State) < 0)
        return;
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,
            "State",((PyObject*)SbkPySide_QtMultimedia_QAudio_State));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_State,(long) QAudio::ActiveState, "ActiveState");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"ActiveState", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_State->tp_dict,"ActiveState", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_State,(long) QAudio::SuspendedState, "SuspendedState");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"SuspendedState", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_State->tp_dict,"SuspendedState", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_State,(long) QAudio::StoppedState, "StoppedState");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"StoppedState", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_State->tp_dict,"StoppedState", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtMultimedia_QAudio_State,(long) QAudio::IdleState, "IdleState");
    PyDict_SetItemString(Sbk_QAudio_Type.super.ht_type.tp_dict,"IdleState", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtMultimedia_QAudio_State->tp_dict,"IdleState", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QAudio::State");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::State");
    // end of enum State


    qRegisterMetaType< ::QAudio::Mode >("QAudio::Mode");
    qRegisterMetaType< ::QAudio::Error >("QAudio::Error");
    qRegisterMetaType< ::QAudio::State >("QAudio::State");
}

