/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtsql_python.h"

#include "qsql_wrapper.h"

// Extra includes
#include <QtSql/qsql.h>



// Target ---------------------------------------------------------

extern "C" {
static PyMethodDef Sbk_QSql_methods[] = {

    {0} // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QSql_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtSql.QSql",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QSql_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              0,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QSql::ParamType >::toPython(
        Shiboken::Converter<QSql::ParamType>::toCpp(self)
        & Shiboken::Converter< QSql::ParamType >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QSql::ParamType >::toPython(
        Shiboken::Converter<QSql::ParamType>::toCpp(self)
        | Shiboken::Converter< QSql::ParamType >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QSql::ParamType >::toPython(
        Shiboken::Converter<QSql::ParamType>::toCpp(self)
        ^ Shiboken::Converter< QSql::ParamType >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtSql_QSql_ParamTypeFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QSql::ParamType >::toPython(
        ~Shiboken::Converter<QSql::ParamType >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtSql_QSql_ParamTypeFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtSql_QSql_ParamTypeFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtSql_QSql_ParamType_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "ParamType",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtSql_QSql_ParamTypeFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_QSql(PyObject* module)
{
    SbkPySide_QtSqlTypes[SBK_QSQL_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QSql_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QSql_Type);
    Py_INCREF((PyObject*)&Sbk_QSql_Type); //Incref due the 'PyModule_AddObject' steals the reference.
    if (PyType_Ready((PyTypeObject*)&Sbk_QSql_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QSql_Type, "QSql");
    PyModule_AddObject(module, "QSql",
        ((PyObject*)&Sbk_QSql_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: NumericalPrecisionPolicy
    PyTypeObject* SbkPySide_QtSql_QSql_NumericalPrecisionPolicy = Shiboken::Enum::newType("PySide.QtSql.QSql.NumericalPrecisionPolicy");
    SbkPySide_QtSqlTypes[SBK_QSQL_NUMERICALPRECISIONPOLICY_IDX] = SbkPySide_QtSql_QSql_NumericalPrecisionPolicy;
    if (PyType_Ready(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy) < 0)
        return;
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,
            "NumericalPrecisionPolicy",((PyObject*)SbkPySide_QtSql_QSql_NumericalPrecisionPolicy));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy,(long) QSql::LowPrecisionInt32, "LowPrecisionInt32");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"LowPrecisionInt32", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy->tp_dict,"LowPrecisionInt32", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy,(long) QSql::LowPrecisionInt64, "LowPrecisionInt64");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"LowPrecisionInt64", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy->tp_dict,"LowPrecisionInt64", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy,(long) QSql::LowPrecisionDouble, "LowPrecisionDouble");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"LowPrecisionDouble", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy->tp_dict,"LowPrecisionDouble", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy,(long) QSql::HighPrecision, "HighPrecision");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"HighPrecision", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_NumericalPrecisionPolicy->tp_dict,"HighPrecision", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QSql::NumericalPrecisionPolicy");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::NumericalPrecisionPolicy");
    // end of enum NumericalPrecisionPolicy

    // init enum: Location
    PyTypeObject* SbkPySide_QtSql_QSql_Location = Shiboken::Enum::newType("PySide.QtSql.QSql.Location");
    SbkPySide_QtSqlTypes[SBK_QSQL_LOCATION_IDX] = SbkPySide_QtSql_QSql_Location;
    if (PyType_Ready(SbkPySide_QtSql_QSql_Location) < 0)
        return;
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,
            "Location",((PyObject*)SbkPySide_QtSql_QSql_Location));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_Location,(long) QSql::BeforeFirstRow, "BeforeFirstRow");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"BeforeFirstRow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_Location->tp_dict,"BeforeFirstRow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_Location,(long) QSql::AfterLastRow, "AfterLastRow");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"AfterLastRow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_Location->tp_dict,"AfterLastRow", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QSql::Location");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Location");
    // end of enum Location

    // init enum: ParamTypeFlag
    PyTypeObject* SbkPySide_QtSql_QSql_ParamTypeFlag = Shiboken::Enum::newType("PySide.QtSql.QSql.ParamTypeFlag");
    SbkPySide_QtSql_QSql_ParamTypeFlag->tp_as_number = &SbkPySide_QtSql_QSql_ParamTypeFlag_as_number;
    SbkPySide_QtSqlTypes[SBK_QSQL_PARAMTYPEFLAG_IDX] = SbkPySide_QtSql_QSql_ParamTypeFlag;
    if (PyType_Ready(SbkPySide_QtSql_QSql_ParamTypeFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,
            "ParamTypeFlag",((PyObject*)SbkPySide_QtSql_QSql_ParamTypeFlag));

    // init flags class: QFlags<QSql::ParamTypeFlag>
    SbkPySide_QtSqlTypes[SBK_QFLAGS_QSQL_PARAMTYPEFLAG__IDX] = &SbkPySide_QtSql_QSql_ParamType_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtSql_QSql_ParamType_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,
            "ParamType",((PyObject*)&SbkPySide_QtSql_QSql_ParamType_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_ParamTypeFlag,(long) QSql::In, "In");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"In", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_ParamTypeFlag->tp_dict,"In", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_ParamTypeFlag,(long) QSql::Out, "Out");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"Out", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_ParamTypeFlag->tp_dict,"Out", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_ParamTypeFlag,(long) QSql::InOut, "InOut");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"InOut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_ParamTypeFlag->tp_dict,"InOut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_ParamTypeFlag,(long) QSql::Binary, "Binary");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"Binary", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_ParamTypeFlag->tp_dict,"Binary", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QSql::ParamTypeFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ParamTypeFlag");
    // end of enum ParamTypeFlag

    // init enum: TableType
    PyTypeObject* SbkPySide_QtSql_QSql_TableType = Shiboken::Enum::newType("PySide.QtSql.QSql.TableType");
    SbkPySide_QtSqlTypes[SBK_QSQL_TABLETYPE_IDX] = SbkPySide_QtSql_QSql_TableType;
    if (PyType_Ready(SbkPySide_QtSql_QSql_TableType) < 0)
        return;
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,
            "TableType",((PyObject*)SbkPySide_QtSql_QSql_TableType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_TableType,(long) QSql::Tables, "Tables");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"Tables", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_TableType->tp_dict,"Tables", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_TableType,(long) QSql::SystemTables, "SystemTables");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"SystemTables", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_TableType->tp_dict,"SystemTables", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_TableType,(long) QSql::Views, "Views");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"Views", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_TableType->tp_dict,"Views", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtSql_QSql_TableType,(long) QSql::AllTables, "AllTables");
    PyDict_SetItemString(Sbk_QSql_Type.super.ht_type.tp_dict,"AllTables", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtSql_QSql_TableType->tp_dict,"AllTables", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QSql::TableType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TableType");
    // end of enum TableType


    qRegisterMetaType< ::QSql::NumericalPrecisionPolicy >("QSql::NumericalPrecisionPolicy");
    qRegisterMetaType< ::QSql::Location >("QSql::Location");
    qRegisterMetaType< ::QSql::ParamTypeFlag >("QSql::ParamTypeFlag");
    qRegisterMetaType< ::QSql::ParamType >("QSql::ParamType");
    qRegisterMetaType< ::QSql::TableType >("QSql::TableType");
}

